#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Dialog.h>
#include "xmdproto.h"
#include "xmddefs.h"

char *Version = "X Magical Dron ver. 1.28  / Team Ayanami 1997 ";


/* --- main.c $BFb$G<g$K;HMQ$5$l$k30ItJQ?t(B --- */

Widget toplevel, form, canvas2, start;
Widget form2, status_l, target_l, tama_l, tama, title;
Widget keybind, toggle1, toggle2;
Widget replay_dialog, big;
Widget popup_form, popup_replay, popup_quit;
int fd;
int execLock = 0;
Display *disp;
Colormap cmap;
XColor color, def, xcolor[7], pad, canvas_bg;
GC gc1;
XtInputId selectid;
int map_last[YOKO][TATE];
int sabun[YOKO][TATE];
char *col[]={
  "red",
  "green",
  "blue",
  "yellow",
  "gold",   /* kieru */
  "white"   /* kuru */
};
char *cantput = "Can't put drop!";
char unterminated_mes[150];

/* --- $B$3$3$^$G(B --- */



/* --- xmd.h $BFb$G(B extern$B@k8@$5$l$F$$$k30ItJQ?t(B --- */

xmd_queue *q_start;
xmd_queue *q_head;
int pr_q_size;         /* present queue size */

Widget canvas, message, names, target, popup_shell, status;
Widget scorelist, winlist;
int map[YOKO][TATE];
int kiepuyo = 0;
int port = PORT;
int interval = 7000;  /*  max 7000(ms)
			  min 1500(ms)  */
XtIntervalId id_timerequest;
int st =  0;      /* st  = STATUS, ta = TARGET */
int ta = -1;      /* target '-1' = Random */
int mypd;
int yabasa[10];
char servername[100];
char mynick[10];
int score;
int persons = 0;
int winner;
char nicknames[10][10];
String namelist[15];

int penalty[11] = {0,0,1,1,2,3,4,4,5,5,6};
/* "pena[2] => 1" means "2-rensa => 1column attack" */

int Lock = 0;
XtAppContext app_con;

struct mychar_{
  int x;         /* x is 0 to YOKO-1 (x zahyou) */
  int color;
  int number;
  int zanzou;    /* animation color name */
  int amari;
}mychar;

XtIntervalId clr_mes_id;
int set_clr_mes_id = 0;

struct score__{
  int rensa[11];
  int score;
}score_;          /* $B%2!<%`%;%C%H;~$N%9%3%"I=<(MQ9=B$BN(B */

struct wintable_{
  char nick[10];
  int win;
  int existnow;
}wintable[10];    /* $BC/$,2?2s>!$C$?$+$rJ]B8$7$^$9(B */

int highscore = 0;
String Scorelist[15];
String Winlist[13];

/* --- $B$3$3$^$G(B --- */


/* -Wall$B;~$N(Bwarning$BKI;_MQ!"%W%m%H%?%$%W@k8@(B */
void XtResizeWidget(Widget w,
		    Dimension width,
		    Dimension height,
		    Dimension border_width);
/* <X11/IntrinsicP.h> $B$G@k8@$5$l$F$k$_$?$$$@$1$I(B... */



void draw(Widget w){
  int i, j, k, drawcolor;
  Dimension width, height, w1, h1;

  XtVaGetValues(w, 
		XtNwidth, &width,
		XtNheight, &height,
		NULL);
  w1 = width / YOKO; 
  h1 = height / TATE; 

  for(k=0; k<2; k++){
    for(i=0; i<YOKO; i++){ 
      for(j=0; j<TATE; j++){
	
	if(map[i][j] != map_last[i][j]){
	  drawcolor = map[i][j];
	  if(drawcolor == -1){
	    XSetForeground(disp, gc1, canvas_bg.pixel);
	  }else{
	    if(map[i][j] > 5 || map[i][j] < -1){
	      fprintf(stderr,"illegal color! col.no. = %d\n",map[i][j]);
	      map[i][j]=0;
	    }
	    XSetForeground(disp, gc1, xcolor[map[i][j]].pixel);
	  }
	  XFillArc(XtDisplay(w), XtWindow(w), gc1,
		   w1*i, h1*j, 
		   w1, h1,
		   0, 360*64);
	}
      }
    }
  }
  
  for(i=0; i<YOKO; i++)
    for(j=0; j<TATE; j++)
      map_last[i][j] = map[i][j];
  
  XSync(XtDisplay(w), FALSE);
}


void redraw(Widget w){
  int i, j;

  if(w == canvas){
    if(st!=0){
      XClearWindow(XtDisplay(canvas), XtWindow(canvas));
      for(i=0; i<YOKO; i++)
	for(j=0; j<TATE; j++)
	  map_last[i][j] = 100; /* dummy */
      draw(canvas);
    }
  }
}


void draw2(Widget w){
  Dimension width, height, w1, h1;

  if(w == canvas2){

    XClearWindow(XtDisplay(w), XtWindow(w));
    XtVaGetValues(w, 
		  XtNwidth, &width,
		  NULL);
    XtVaGetValues(canvas,
		  XtNheight, &height,
		  NULL);

    w1 = width / YOKO; 
    h1 = height / TATE; 


    XSetForeground(disp, gc1, pad.pixel);
    XFillRectangle(XtDisplay(w), XtWindow(w), gc1, 
		   w1*(mychar.x), h1*3, w1, h1/3);

    if(mychar.zanzou != -1){
      XSetForeground(disp, gc1, xcolor[mychar.color].pixel);
      XFillArc(XtDisplay(w), XtWindow(w), gc1, 
	       w1*(mychar.x), 0,
	       w1, h1,
	       0, 360*64);
    }


    if(mychar.color != -1){
      XSetForeground(disp, gc1, xcolor[mychar.color].pixel);
      XFillArc(XtDisplay(w), XtWindow(w), gc1, 
	       w1*(mychar.x), h1*2,
	       w1, h1,
	       0, 360*64);
    }
    XSync(XtDisplay(w), FALSE);
  }
}

void bigscreen(Widget w, XtPointer client_data, XtPointer call_data){

  XtResizeWidget(toplevel, 
		 600, /* X */ 
		 800, /* Y */
		 1);

  redraw(canvas);
  draw2(canvas2);
}

void gamestart(Widget w, XtPointer client_data, XtPointer call_data){
  char tmp[80];

  if(st == 0){
    if(persons >= 2){
      sprintf(tmp,"START;");
      write(fd,tmp,strlen(tmp)); 
      XtVaSetValues(status,
		    XtNlabel, "Game",
		    NULL);
    }else{
      XtVaSetValues(message,
		    XtNlabel, "Too few players! Can't start!",
		    NULL);
      setclr();
    }
  }
}

void start2(Widget w, XEvent *ev, String *dir){
  gamestart(w, NULL, NULL);
}

void okurisaki(Widget w, XEvent *ev, String *who ){
  int i;
  char tmp[13];

  for(i=0; i<persons; i++){

    sprintf(tmp,"%d",i);
    if(strcmp(tmp,*who) == 0){

      strncpy(tmp, namelist[i+2], 12);  /* namelist[0],[1] is title */
      tmp[12] = '\0';

      XtVaSetValues(target,
		    XtNlabel, tmp,
		    NULL);
      ta = i;
      break;
    }

  }
  if(strcmp("r",*who)==0){
    XtVaSetValues(target,
		  XtNlabel, "Random", 
		  NULL);
    ta = -1;
  }

}

void addmypuyo(Widget w){
  char tmp[30];

  if(st != 1)
    return;

  sprintf(tmp, "REQUEST:%d:%d:1;", mypd, mypd);
  write(fd,tmp, strlen(tmp));

}


void get(Widget w){
  int i = 0;
  int j = mychar.x;
  char tmp[10];

  if(st != 1 || Lock != 0)
    return;

  while(map[j][i] != -1 && i<TATE)
    i++;

  if(i != 0){
    i--;
    if(map[j][i] == mychar.color || mychar.color == -1){

      /* get! */

      /* onazi iro ha ikkini get! */
      
      do{
	(mychar.number)++;
	mychar.color = map[j][i];
	map[j][i] = -1;
	i--;
      }while(i >= 0 && map[j][i] == mychar.color);

      draw(canvas);
      mychar.zanzou = mychar.color;
      draw2(canvas2);

      sprintf(tmp,"%d",mychar.number);
      XtVaSetValues(tama,
		    XtNlabel, tmp,
		    NULL);


      XtAppAddTimeOut(app_con, WAIT,
		      wait1,
		      NULL);

    }
  }

}

void wait1(XtPointer client_data, XtIntervalId *id){
      mychar.zanzou = -1;
      draw2(canvas2);
}


void put(Widget w){
  int k, l, number;
  int i = TATE - 1;   /* sita kara siraberu */
  int j = mychar.x;
  int topcol, already = 0;         /* sudeni ikutsu tunagatte iruka */
  int kieru = 0;      /* Zero means FALSE */

  char tmp[10];

  if(st != 1 || Lock != 0)
    return;

  if(mychar.number != 0){

    while(map[j][i] == -1 && i>=0)
      i--;

    l = i;
    topcol = map[j][l];
    while(map[j][l] == topcol && l>=0){
      already++;
      l--;
    }

    number = mychar.number;
    if(i >= TATE - 1){
      /* NG 1*/
      cannotput();
    }else if(topcol != mychar.color && 
	     number < DEL_NUM && 
	     i + number >= TATE){
      /* NG 2*/
      cannotput();
    }else if(topcol == mychar.color && 
	     i + number >= TATE &&
	     already + number < DEL_NUM){
      /* NG 3*/
      cannotput();
    }else{
      /* PUT OK! */
      mychar.amari = number - (TATE - 1 - i);
      if(mychar.amari < 0) 
	mychar.amari = 0;
      number = number - mychar.amari;

      if(topcol == mychar.color && already + number + mychar.amari >= DEL_NUM){
	kieru = 1;
      }else if(topcol != mychar.color && number + mychar.amari >= DEL_NUM){
	kieru = 1;
      }

      
      for(k = 0; k < number; k++){
	(mychar.number)--;
	map[j][i+1+k] = mychar.color;
      }

      mychar.number = 0;
      mychar.color = -1;

      sprintf(tmp,"%d",mychar.number);
      XtVaSetValues(tama,
		    XtNlabel, tmp,
		    NULL);

      draw2(canvas2);

      if(kieru == 1){

	delete();
	mychar.amari = 0;
      }

      /* $B8=:_!"(Bdraw() $BI,MW!#(B */
      draw(canvas);
    }
  }

}


void cannotput(void){
  XtVaSetValues(message,
		XtNlabel, cantput,
		NULL);
  setclr();
}

void xmdconnect(void){
  char tmp[80];

  fd = sconnect();          /* connection estublish */
  sprintf(tmp,"NICK:%s;",mynick);
  write(fd,tmp,strlen(tmp));
}


void move(Widget w, XEvent *ev, String *dir){
  if(strcmp("L",*dir) == 0)
    (mychar.x)--;
  else
    (mychar.x)++;

  if(mychar.x < 0)
    mychar.x = YOKO - 1;
  else if(mychar.x > YOKO-1 )
    mychar.x = 0;             /* Char move --- Loop */

  draw2(canvas2);
}

void yn_yes(Widget w, XtPointer dummy, XtPointer dummy2){
  XtPopdown(popup_shell);

  /* global hensu initialize! */
  v_init();

  xmdconnect();

  XtRemoveInput(selectid);

  selectid = XtAppAddInput(app_con, fd, 
			   (XtPointer)XtInputReadMask, 
			   xselect, 
			   toplevel); 

}

void yn_no(Widget w, XtPointer dummy, XtPointer dummy2){
  printf("\nThank you! (X magical dron / Team Ayanami)\n");
  exit(0);
}

void v_init(void){
  int i, j;
  char tmp[20];

  st=0;
  XtVaSetValues(status,
		XtNlabel,"Wait",
		NULL);
  ta=-1;
  XtVaSetValues(target,
		XtNlabel,"Random",
		NULL);

  XtVaSetValues(tama,
		XtNlabel,"0",
		NULL);

  XtVaSetValues(message,
		XtNlabel,"",
		NULL);
  
  persons = 0;
  interval = 7000;
  kiepuyo = 0;

  mychar.x = YOKO - 1;
  mychar.color = -1;
  mychar.number = 0;
  mychar.zanzou = -1;
  mychar.amari = 0;


  strcpy(namelist[0], "Player's nick/status");
  strcpy(namelist[1], " ");

  for(i=2; i<=11; i++){
    sprintf(tmp,"%d: ",i-2);
    strcpy(namelist[i], tmp);
  }
  
  strcpy(namelist[12], " ");
  strcpy(namelist[13], "R: Random");
  namelist[14]= NULL;

  XawListChange(names, namelist, 0, 0, False);

  for(i=0; i<YOKO; i++){
    for(j=0; j<TATE; j++){
      map_last[i][j] = -1;   
      map[i][j] = -1;
    }
  } 

  XClearWindow(XtDisplay(canvas), XtWindow(canvas));
  XClearWindow(XtDisplay(canvas2), XtWindow(canvas2));
  draw2(canvas2);

  for(i=0; i<10; i++)
    strcpy(nicknames[i], "NOUSE");

  for(i=0; i<10; i++)
    yabasa[i] = TATE - 4;

  unterminated_mes[0] = '\0';

  XtRemoveTimeOut(id_timerequest);

  Lock = execLock = 0;

  /* wintable[]$B$O=i4|2=$7$J$/$FNI$$(B */
  for(i=0; i<11; i++)
    score_.rensa[i] = 0;
  score_.score = 0;


  /* $B0J2<$N#39T$O2x$7$$!#>-Mh!"%P%0$N860x$H$J$k$+$b!#(B */
  q_head = q_start;
  pr_q_size = 0;
  unterminated_mes[0] = '\0';


}

void clr_mes(XtPointer client_data, XtIntervalId *id){

  set_clr_mes_id = 0;

  if(st >= 2)    /* gameover $B$d(B hoge win $B$O>C$5$J$$(B */
    return;
  XtVaSetValues(message,
		XtNlabel, "",
		NULL);
}

void setclr(void){
  if(set_clr_mes_id ==1)
    XtRemoveTimeOut(clr_mes_id);

  clr_mes_id = XtAppAddTimeOut(app_con, 2000,
			       clr_mes,
			       NULL);
  set_clr_mes_id = 1;
}

int main(int argc, char **argv){
  int i,j;
  char tmp[20];
  xmd_queue *q_tmp;

  static String fallback[] = {
    "*translations: #override \\n\
     <Expose>: redraw() draw2()\\n\
     <Configure>: redraw() draw2()\\n\
     None<Key>0: okurisaki(0)\\n\
     None<Key>1: okurisaki(1)\\n\
     None<Key>2: okurisaki(2)\\n\
     None<Key>3: okurisaki(3)\\n\
     None<Key>4: okurisaki(4)\\n\
     None<Key>5: okurisaki(5)\\n\
     None<Key>6: okurisaki(6)\\n\
     None<Key>7: okurisaki(7)\\n\
     None<Key>8: okurisaki(8)\\n\
     None<Key>9: okurisaki(9)\\n\
     None<Key>r: okurisaki(r)\\n\
     None<Key>s: start2()\\n\
     None<Key>d: move(L)\\n\
     None<Key>f: move(R)\\n\
     None<Key>space: addmypuyo()\\n\
     None<Key>j: get()\\n\
     None<Key>k: put()\\n\
     None<Key>Left: move(L)\\n\
     None<Key>Right: move(R)\\n\
     None<Key>z: get()\\n\
     None<Key>x: put()\\n\
     None<Key>Down: get()\\n\
     None<Key>Up: put()",

    "*title.justify: center",

    "*canvas.background: orange",
    "*canvas.fromVert: title",

    "*message.fromVert: canvas",
    "*canvas2.fromVert: message",
    "*canvas2.background: orange",

    "*names.fromVert: title",
    "*names.fromHoriz: canvas",    
    "*form2.fromVert: names",
    "*form2.fromHoriz: message",

    "*title.borderWidth: 0",
    "*start.label: Start!",
    "*start.borderWidth: 1",
    "*big.label: Big screen",
    "*start.borderWidth: 1",
    "*canvas.width: 300",
    "*canvas.height: 430",

    "*names.width: 150",
    "*names.height: 400", 
    "*names.rowSpacing: 12",

    "*names.defaultColumns: 1",
    "*names.forceColumns: TRUE",
    "*message.label: ",
    "*message.width: 300",
    "*canvas2.width: 300",
    "*canvas2.height: 170",

    "*status_l.borderWidth: 0",
    "*status_l.label: YOUR STATUS",

    "*status.width: 140",
    "*status.fromVert: status_l",
    "*status.label: Wait",

    "*target_l.borderWidth: 0",
    "*target_l.fromVert: status",
    "*target_l.label: TARGET",

    "*target.width: 140",
    "*target.fromVert: target_l",
    "*target.label: Random",

    "*tama_l.borderWidth: 0",
    "*tama_l.fromVert: target",
    "*tama_l.label: Jewel",

    "*tama.width: 140",
    "*tama.fromVert: tama_l",
    "*tama.label: 0",

    "*big.fromVert: tama",
    "*big.vertDistance: 92",
    "*big.horizDistance: 40",

    "*start.fromVert: big",
    "*start.horizDistance: 55",

    "*popup_replay.label: Replay",
    "*popup_quit.label: Quit",

    "*scorelist.width: 150",
    "*scorelist.height: 280", 
    "*scorelist.rowSpacing: 6",
    "*scorelist.defaultColumns: 1",
    "*scorelist.forceColumns: TRUE",

    "*winlist.fromHoriz: scorelist",
    "*winlist.width: 150",
    "*winlist.height: 280", 
/*    "*winlist.height: 245", */
    "*winlist.rowSpacing: 6",
    "*winlist.defaultColumns: 1",
    "*winlist.forceColumns: TRUE",

    "*popup_replay.fromVert: scorelist",
    "*popup_replay.fromVert: winlist",
    "*popup_quit.fromVert: scorelist",
    "*popup_quit.fromVert: winlist",
    "*popup_quit.fromHoriz: popup_replay",

    NULL
  };

  static XtActionsRec actions[] = {
    {"redraw", (XtActionProc)redraw},
    {"draw2", (XtActionProc)draw2},
    {"okurisaki", (XtActionProc)okurisaki},
    {"move", (XtActionProc)move},
    {"start2", (XtActionProc)start2}, /* s$B%-!<$G$N%9%?!<%HMQ%"%/%7%g%s(B */
    {"addmypuyo", (XtActionProc)addmypuyo},
    {"get", (XtActionProc)get},
    {"put", (XtActionProc)put}
  };



  q_start = q_tmp = (xmd_queue *)malloc(sizeof(xmd_queue));
  for(i=0; i<QUEUE_; i++){
    q_tmp->next = (xmd_queue *)malloc(sizeof(xmd_queue));
    q_tmp = q_tmp->next;
  }
  q_tmp->next = q_start;      /* Ring List */

  /* initialize */
  q_head = q_start;
  pr_q_size = 0;
  unterminated_mes[0] = '\0';


  /* $B%9%3%"I=<(7O$N=i4|2=(B */
  for(i = 0; i < 11; i++)
    score_.rensa[i] = 0;
  score_.score = 0;
  for(i = 0; i < 10; i++){
    strcpy(wintable[i].nick, "");
    wintable[i].win = 0;
  }


  Param(argc, argv);        /* paramater analysis */


  toplevel = XtVaAppInitialize(&app_con, AppClass, NULL, 0, 
			       &argc, argv, fallback, NULL);


  disp = XtDisplay(toplevel);
  cmap = DefaultColormap(disp, 0);
  gc1 = XCreateGC(disp, RootWindow(disp,0), 0, NULL);

  for(i=0; i<6; i++){
    if(XAllocNamedColor(disp, cmap, col[i], &xcolor[i], &def) == 0){
      fprintf(stderr,"Can't allocate color '%s'. exit.\n", col[i]);
      exit(1);
    }
  }

  if(XAllocNamedColor(disp, cmap, CHAR_COLOR, &pad, &def)==0){
    fprintf(stderr,"Can't allocate color '%s'. exit.\n", BGCOLOR);
    exit(1);
  }

  if(XAllocNamedColor(disp, cmap, BGCOLOR, &canvas_bg, &def)==0){
    fprintf(stderr,"Can't allocate color '%s'. exit.\n", BGCOLOR);
    exit(1);
  }

  xmdconnect();                /* connect to server */

  form = XtVaCreateManagedWidget("form",
 				 formWidgetClass, toplevel, NULL);
  title = XtVaCreateManagedWidget("title",
				  labelWidgetClass, form, NULL);
  canvas = XtVaCreateManagedWidget("canvas",
				   widgetClass, form, NULL);
  names = XtVaCreateManagedWidget("names",
				  listWidgetClass, form, NULL);
  message = XtVaCreateManagedWidget("message",
				    labelWidgetClass, form, NULL);
  canvas2 = XtVaCreateManagedWidget("canvas2",
				    widgetClass, form, NULL);
  form2 = XtVaCreateManagedWidget("form2",
				  formWidgetClass, form, NULL);
  status_l = XtVaCreateManagedWidget("status_l",
				  labelWidgetClass, form2, NULL);
  status = XtVaCreateManagedWidget("status",
				  labelWidgetClass, form2, NULL);
  target_l = XtVaCreateManagedWidget("target_l",
				  labelWidgetClass, form2, NULL);
  target = XtVaCreateManagedWidget("target",
				  labelWidgetClass, form2, NULL);
  tama_l = XtVaCreateManagedWidget("tama_l",
				  labelWidgetClass, form2, NULL);
  tama = XtVaCreateManagedWidget("tama",
				  labelWidgetClass, form2, NULL);


  big = XtVaCreateManagedWidget("big",
				   commandWidgetClass, form2, NULL);
  start = XtVaCreateManagedWidget("start",
				   commandWidgetClass, form2, NULL);

  popup_shell = XtVaCreatePopupShell("xmd Result",
				     topLevelShellWidgetClass, toplevel,NULL);

  popup_form = XtVaCreateManagedWidget("popup_form",
				       formWidgetClass, popup_shell, NULL);
  scorelist = XtVaCreateManagedWidget("scorelist",
				      listWidgetClass, popup_form, NULL);
  winlist = XtVaCreateManagedWidget("winlist",
				    listWidgetClass, popup_form, NULL);
  popup_replay = XtVaCreateManagedWidget("popup_replay",
					commandWidgetClass, popup_form, NULL);
  popup_quit = XtVaCreateManagedWidget("popup_quit",
				       commandWidgetClass, popup_form, NULL);

  XtVaSetValues(title,
		XtNlabel, Version,
		XtNwidth, 454,
		NULL);

  mychar.x = YOKO - 1;
  mychar.color = -1;
  mychar.number = 0;
  mychar.zanzou = -1;
  mychar.amari = 0;


  for(i=0; i<=14; i++)
    Scorelist[i] = (char *)malloc(sizeof(char) * 50);

  for(i=0; i<=12; i++)
    Winlist[i] = (char *)malloc(sizeof(char) * 50);

  for(i=0; i<=14; i++)
    namelist[i] = (char *)malloc(sizeof(char) * 21);


  strcpy(namelist[0], "Player's nick/status");
  strcpy(namelist[1], " ");

  for(i=2; i<=11; i++){
    sprintf(tmp,"%d: ",i-2);
    strcpy(namelist[i], tmp);
  }
  
  strcpy(namelist[12], " ");
  strcpy(namelist[13], "R: Random");
  namelist[14]= NULL;

  XawListChange(names, namelist, 0, 0, True);

  for(i=0; i<YOKO; i++){
    for(j=0; j<TATE; j++){
      map_last[i][j] = -1;   
      map[i][j] = -1;
    }
  }


  for(i=0; i<10; i++)
    strcpy(nicknames[i], "NOUSE");

  for(i=0; i<10; i++)
    yabasa[i] = TATE - 4;


  XtAppAddActions(app_con, actions, XtNumber(actions));

  XtAddCallback(start, XtNcallback, gamestart, &fd);
  XtAddCallback(big, XtNcallback, bigscreen, NULL);
  XtAddCallback(popup_replay, XtNcallback, yn_yes, NULL);
  XtAddCallback(popup_quit, XtNcallback, yn_no, NULL);

  XtAppAddTimeOut(app_con, 5000,
		  mystate,
		  NULL);

  XtAppAddTimeOut(app_con, 1000,
		  mystate_refresh,
		  NULL);

  XtAppAddTimeOut(app_con, QUEUE_CHECK_INTERVAL,
		  queue_check,
		  NULL);

  clr_mes_id = XtAppAddTimeOut(app_con, 3000,
			       clr_mes,
			       NULL);
  set_clr_mes_id = 1;

  selectid = XtAppAddInput(app_con, fd, 
			   (XtPointer)XtInputReadMask, 
			   xselect, 
			   toplevel); 
                        /* toplevel is dummy */

  XtRealizeWidget(toplevel);
  XtAppMainLoop(app_con);

  return 1;

}
