#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/time.h>
#include <unistd.h>
#include "xmd.h"

/* for freeBSD */
#ifndef TCP_NODELAY
#include <netinet/tcp.h>
#endif

extern int port;

int  sconnect(void){
  struct sockaddr_in    addr;
  struct hostent *hp;
  int sockflag = 1;
  int fd;
  
    /*
     *  $B%=%1%C%H$r:n$k!#$3$N%=%1%C%H$O(BUNIX$B%I%a%$%s$G!"%9%H%j!<%`7?%=%1%C%H!#(B
     */
    if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
        perror("socket");
        exit(1);
    }

    setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, (char *)&sockflag, sizeof(int));
    setsockopt(fd, IPPROTO_TCP, TCP_NODELAY, (char *)&sockflag, sizeof(int));

    memset((char *)&addr, 0, sizeof(addr));

  /* $B%=%1%C%H$NL>A0$rF~$l$F$*$/(B */

    if ((hp = gethostbyname(servername)) == NULL) {
	fprintf(stderr,"No such host\n");
	exit(1);
    }
    memcpy(&addr.sin_addr, hp->h_addr, hp->h_length);
    addr.sin_family = AF_INET;
    addr.sin_port = htons(port);

    if (connect(fd, (struct sockaddr *)&addr, sizeof(addr)) < 0){
        perror("connect");
        exit(1);
    }
  return fd;
}




